/*C**************************************************************************
* O:			RunningModes.c
*----------------------------------------------------------------------------
* Copyright (c) 2004 Atmel.
*----------------------------------------------------------------------------
* J:			avr434_0_0_1
* :			1.2
*----------------------------------------------------------------------------
* ړI:
* ̧قPSCg`𐶐۸т񋟂܂B
****************************************************************************/

/*_____ ݸٰ ___________________________________________________________*/
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "lib_mcu/pll/pll_drv.h"

#define E_N_RAMPS		1	/* E_N_RAMPS : PSC0XΔԍ4,2,1,0() */
//#define E_OVERLAPPED		/* E_OVERLAPPED : 1XΓł̏dȂl̎ */
//#define E_RETRIG_0		/* E_RETRIG_0 : ċN0͋ */
#define SO32				/* PSC1SO32O͊gp */

#ifdef E_OVERLAPPED
#define DEAD_TIME_0		50
#define ON_TIME_0		100
#define DEAD_TIME_1		75
#define ON_TIME_1		125
#else
#define DEAD_TIME_0		50
#define ON_TIME_0		75
#define DEAD_TIME_1		100
#define ON_TIME_1		125
#endif

/*F**************************************************************************
* O: PSC0
****************************************************************************/
void PSC0_Init (void)
{
  PSOC0 = (1<<POEN0A)|(1<<POEN0B);								// o0,o1
  OCR0SAH = HIGH(DEAD_TIME_0);									// َ0ݒ
  OCR0SAL = LOW(DEAD_TIME_0);
  OCR0RAH = HIGH(ON_TIME_0);									// ON0ݒ
  OCR0RAL = LOW(ON_TIME_0);
  OCR0SBH = HIGH(DEAD_TIME_1);									// َ1ݒ
  OCR0SBL = LOW(DEAD_TIME_1);
  OCR0RBH = HIGH(ON_TIME_1);									// ON1ݒ
  OCR0RBL = LOW(ON_TIME_1);

#if (E_N_RAMPS == 4)
  PCNF0 = (1<<PMODE01)|(1<<PCLKSEL0)|(1<<POP0);					/* 4XΓ */
#else
#if (E_N_RAMPS == 2)
  PCNF0 = (1<<PMODE00)|(1<<POP0);								/* 2XΓ */
#else
#if (E_N_RAMPS == 1)
  PCNF0 = (0<<PMODE01)|(0<<PMODE00)|(1<<POP0);					/* I/Oۯł1XΓ */
//  PCNF0 = (0<<PMODE01)|(0<<PMODE00)|(1<<PCLKSEL0)|(1<<POP0);	/* PLLł1XΓ */
#else
  PCNF0 = (1<<PMODE01)|(1<<PMODE00)|(1<<POP0);					/* 񓮍 */
#endif
#endif
#endif

#ifdef E_RETRIG_0
  PFRC0A = (1<<PRFM0A3)|(1<<PELEV0A)|(1<<PFLTE0A);				// ċN,L,hg틖
#else
  PFRC0A = 0;
#endif

  PFRC0B = 0;
  PCTL0 = (1<<PRUN0);											/* s !! */
}

#ifdef SO32
/*F**************************************************************************
* O: PSC1
****************************************************************************/
void PSC1_Init (void)
{
  PSOC1 = (1<<POEN1A)|(1<<POEN1B);								// o0,o1
  OCR1SAH = HIGH(0x0008);										// َ0ݒ
  OCR1SAL = LOW(0x0008);
  OCR1RAH = HIGH(0x0400);										// ON0ݒ
  OCR1RAL = LOW(0x0400);
  OCR1SBH = HIGH(0x0010);										// َ1ݒ
  OCR1SBL = LOW(0x0010);
  OCR1RBH = HIGH(0x0200);										// ON1ݒ
  OCR1RBL = LOW(0x0200);
//  PCNF1 = (1<<PMODE11)|(0<<PCLKSEL0)|(1<<POP1);				/* I/Oۯł4XΓ */
  PCNF1 = (1<<PMODE11)|(1<<PCLKSEL0)|(1<<POP1);					/* PLLۯł4XΓ */
  PFRC1A = 0;
  PFRC1B = 0;
  PCTL1 = (1<<PRUN1);											/* s !! */
}
#endif

/*F**************************************************************************
* O: PSC2
****************************************************************************/
void PSC2_Init (void)
{
  PSOC2 = (1<<POEN2A)|(1<<POEN2B);								// o0,o1
  OCR2SAH = HIGH(0x0008);										// َ0ݒ
  OCR2SAL = LOW(0x0008);
  OCR2RAH = HIGH(0x0400);										// ON0ݒ
  OCR2RAL = LOW(0x0400);
  OCR2SBH = HIGH(0x0010);										// َ1ݒ
  OCR2SBL = LOW(0x0010);
  OCR2RBH = HIGH(0x0200);										// ON1ݒ
  OCR2RBL = LOW(0x0200);
  PCNF2 = (1<<PMODE21)|(1<<POP2);								// I/Oۯł4XΓ
  PFRC2A = 0;
  PFRC2B = 0;
  PCTL2 = (1<<PRUN2);											/* s !! */
}

/*F**************************************************************************
* O: main
****************************************************************************/
int main (void)
{
  OSCCAL=120;
  Start_pll_64_mega();		// 64MHz PLLn
  Wait_pll_ready();			// PLLҋ@
  PSC0_Init();				// PSC0
#ifdef SO32
  PSC1_Init();				// PSC1
#endif
  PSC2_Init();				// PSC2
  while(1) {;}
}




